// Gamelab server core
/*jslint nomen: true, node: true*/
"use strict";
var fs = require('fs'),
	os = require('os'),
	expressjs = require('express'),
	http = require('http'),
	path = require('path'),
	ejs = require('ejs'),
	io = require('socket.io'),
	gl_MetaDefaults,
	gl_ProjectDir,
	gl_ClientDir,
	gl_SOCKServerStart,
	gl_MetaRead,
	sockServer,
	os_deliniator = '/',
	httpServer,
	express;

if (os.platform() === 'win32') {
	os_deliniator = "\\";
}

gl_ProjectDir = __dirname.split(os_deliniator).slice(0, -1).join(os_deliniator) + os_deliniator;
gl_ClientDir = gl_ProjectDir + 'client' + os_deliniator;

// TODO: Load defaults from gl_Meta.path (gamelab)
gl_MetaDefaults = function (gl_Meta) {
	if (typeof (gl_Meta.httpPort) === "undefined") {
		gl_Meta.httpPort = 9000;
	}
	if (typeof (gl_Meta.sockPort) === "undefined") {
		gl_Meta.sockPort = 9001;
	}
	return gl_Meta;
};

gl_MetaRead = function (callback) {
	fs.readFile(__dirname + '/../.gamelab', function (error, gl_Meta) {
		if (error) {
			console.log('No .gamelab file found, exiting. Perhaps your project is fubar?');
			process.exit();
		}
		try {
			gl_Meta = JSON.parse(gl_Meta.toString());
			gl_Meta = gl_MetaDefaults(gl_Meta);
		} catch (jsonerror) {
			throw (jsonerror);
		} finally {
			callback(gl_Meta);
		}
	});
};

gl_SOCKServerStart = function (gl_Meta) {
	//io.set('log level', 1);
	sockServer = io.listen(httpServer, { log: false });
	sockServer.configure('development', function () {
		sockServer.set('log level', 0);
	});
	sockServer.sockets.on('connection', function (socket) {
		socket.emit('gl_Test', 'Hello Gamelab World!');
	});
};

express = expressjs();

express.set('view engine', 'ejs');
express.set('views', './app/www/');
express.use('/libs', expressjs.static('./app/www/libs'));
express.use('/assets', expressjs.static('./app/www/assets'));
express.use(expressjs.json());
express.use(expressjs.urlencoded());


// App begin
gl_MetaRead(function (gl_Meta) {

	httpServer = http.createServer(express);
	express.set('port', gl_Meta.httpPort);
	express.post("/__quickReload", function (request, response) {
		//console.log(request.body);
		if (request.body.file.indexOf('app/www/') !== -1) {
			sockServer.sockets.emit('__quickReload', {
				file: request.body.file,
				delay: 0
			});
			response.send("client");
		} else {
			sockServer.sockets.emit('__quickReload', {
				file: request.body.file,
				delay: 500
			});
			response.send("server");
		}
	});

	require('./app.js').app({
		http: express
	});
	//gl_HTTPServerStart(gl_Meta);
	httpServer.listen(gl_Meta.httpPort);
	gl_SOCKServerStart(gl_Meta);
	//httpServer.listen(gl_Meta.httpPort);
});